<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.18"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>XHXKit: XHXKit/Classes/DeviceManager/XHXDeviceManager.m 源文件</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">XHXKit
   &#160;<span id="projectnumber">4.10.0.12</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- 制作者 Doxygen 1.8.18 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'搜索');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','搜索');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_x_h_x_device_manager_8m_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">XHXDeviceManager.m</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_x_h_x_device_manager_8m.html">浏览该文件的文档.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno"><a class="line" href="interface_x_h_x_device_manager.html#a1ba09c395cce72715a1744b89e979a71">    1</a></span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">//  XHXDeviceManager.m</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">//  CKKit</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">//  Created by Leovir on 2018/4/4.</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">//</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#import &quot;<a class="code" href="_x_h_x_device_manager_8h.html">XHXDeviceManager.h</a>&quot;</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#import &lt;ifaddrs.h&gt;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#import &lt;arpa/inet.h&gt;</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#import &lt;sys/utsname.h&gt;</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#import &lt;CoreTelephony/CTTelephonyNetworkInfo.h&gt;</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#import &lt;CoreTelephony/CTCarrier.h&gt;</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#import &lt;KKLThirdParty/SAMKeychain.h&gt;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#import &lt;CKKit/CKKit.h&gt;</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define kServiceKey @&quot;KKLOnLine&quot;</span></div>
<div class="line"><a name="l00018"></a><span class="lineno"><a class="line" href="_x_h_x_device_manager_8m.html#a1d3aa2437ceb6e4840f7d45d7654b086">   18</a></span>&#160;<span class="preprocessor">#define kUUIDKey @&quot;uuid&quot;</span></div>
<div class="line"><a name="l00019"></a><span class="lineno"><a class="line" href="_x_h_x_device_manager_8m.html#ae696545da7cf3e06d35f11ba6ad5ebd0">   19</a></span>&#160;<span class="preprocessor">#define gAPPVERSION  [[[NSBundle mainBundle] infoDictionary] objectForKey:@&quot;CFBundleShortVersionString&quot;]</span></div>
<div class="line"><a name="l00020"></a><span class="lineno"><a class="line" href="_x_h_x_device_manager_8m.html#ad1a157d38b212c04911c55d09db5b0dc">   20</a></span>&#160;<span class="keyword">@implementation </span><a class="code" href="interface_x_h_x_device_manager.html">XHXDeviceManager</a></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;+ (NSString *)<a class="code" href="interface_x_h_x_device_manager.html#a6c80a82e571c1dc6730b6bd61747d337">documentDirectory</a></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;{</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    NSString *documentsDirectory = [paths firstObject];</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keywordflow">return</span> documentsDirectory;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;}</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160; </div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;+ (void)openAppStore:(NSString *)appstoreID {</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    NSCAssert(appstoreID != nil, <span class="stringliteral">@&quot;appID not null&quot;</span>);</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="comment">//</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    </div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">#if ONAPPSTORE</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    NSString *reviewURL =   [NSString stringWithFormat:@&quot;https://itunes.apple.com/cn/app/id%@?mt=8&quot;,appstoreID];</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keywordflow">if</span> ([[UIApplication sharedApplication] canOpenURL:[NSURL URLWithString:reviewURL]]) {</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        [[UIApplication sharedApplication] openURL:[NSURL URLWithString:reviewURL]];</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    }</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="preprocessor">#else</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    NSString *reviewURL =   <span class="stringliteral">@&quot;http://static.kaike.la/h5/html/download.html&quot;</span>;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keywordflow">if</span> ([[UIApplication sharedApplication] canOpenURL:[NSURL URLWithString:reviewURL]]) {</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        [[UIApplication sharedApplication] openURL:[NSURL URLWithString:reviewURL]];</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    }</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;}</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;+ (NSString *)<a class="code" href="interface_x_h_x_device_manager.html#a2e073959d4af599e4f30d9328c10f88f">getIOSVersion</a></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;{</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    </div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keywordflow">return</span> [[UIDevice currentDevice] systemVersion];</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;}</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;+ (NSString *)<a class="code" href="interface_x_h_x_device_manager.html#a085a7739cdce0d342f7ee650c0152820">getIPAddress</a></div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;{</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    NSString *address = <span class="stringliteral">@&quot;error&quot;</span>;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keyword">struct </span>ifaddrs *interfaces = NULL;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keyword">struct </span>ifaddrs *temp_addr = NULL;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keywordtype">int</span> success = 0;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="comment">// retrieve the current interfaces - returns 0 on success</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    success = getifaddrs(&amp;interfaces);</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="keywordflow">if</span> (success == 0) {</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        <span class="comment">// Loop through linked list of interfaces</span></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        temp_addr = interfaces;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        <span class="keywordflow">while</span> (temp_addr != NULL) {</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;            <span class="keywordflow">if</span>( temp_addr-&gt;ifa_addr-&gt;sa_family == AF_INET) {</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;                <span class="comment">// Check if interface is en0 which is the wifi connection on the iPhone</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;                <span class="keywordflow">if</span> ([[NSString stringWithUTF8String:temp_addr-&gt;ifa_name] isEqualToString:<span class="stringliteral">@&quot;en0&quot;</span>]) {</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;                    <span class="comment">// Get NSString from C String</span></div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;                    address = [NSString stringWithUTF8String:inet_ntoa(((struct sockaddr_in *)temp_addr-&gt;ifa_addr)-&gt;sin_addr)];</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;                }</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;            }</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;            temp_addr = temp_addr-&gt;ifa_next;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        }</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    }</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <span class="comment">// Free memory</span></div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    freeifaddrs(interfaces);</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    </div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    <span class="keywordflow">return</span> address;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;}</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;+ (NSString *)getUserAgent {</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    NSString *userAgent = [NSString stringWithFormat:@&quot;%@/%@ (%@; iOS %@; Scale/%0.2f; appVersion %@)&quot;, [[NSBundle mainBundle] infoDictionary][(__bridge NSString *)kCFBundleExecutableKey] ?: [[NSBundle mainBundle] infoDictionary][(__bridge NSString *)kCFBundleIdentifierKey], [[NSBundle mainBundle] infoDictionary][@&quot;CFBundleShortVersionString&quot;] ?: [[NSBundle mainBundle] infoDictionary][(__bridge NSString *)kCFBundleVersionKey], [[UIDevice currentDevice] model], [[UIDevice currentDevice] systemVersion], [[UIScreen mainScreen] scale],gAPPVERSION];</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <span class="keywordflow">return</span> userAgent;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;}</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;+ (NSString *)getVersion {</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <span class="keywordflow">return</span> [[[NSBundle mainBundle] infoDictionary] objectForKey:@&quot;CFBundleShortVersionString&quot;];</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;}</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;+ (NSString*)getDeviceModelName {</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    <span class="keyword">struct </span>utsname systemInfo;</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    uname(&amp;systemInfo);</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    NSString *deviceModel = [NSString stringWithCString:systemInfo.machine encoding:NSUTF8StringEncoding];</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    </div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    <span class="comment">//iPhone 系列</span></div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPhone1,1&quot;</span>])    <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPhone 1G&quot;</span>;</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPhone1,2&quot;</span>])    <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPhone 3G&quot;</span>;</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPhone2,1&quot;</span>])    <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPhone 3GS&quot;</span>;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPhone3,1&quot;</span>])    <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPhone 4&quot;</span>;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPhone3,2&quot;</span>])    <span class="keywordflow">return</span> <span class="stringliteral">@&quot;Verizon iPhone 4&quot;</span>;</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPhone4,1&quot;</span>])    <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPhone 4S&quot;</span>;</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPhone5,1&quot;</span>])    <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPhone 5&quot;</span>;</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPhone5,2&quot;</span>])    <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPhone 5&quot;</span>;</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPhone5,3&quot;</span>])    <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPhone 5C&quot;</span>;</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPhone5,4&quot;</span>])    <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPhone 5C&quot;</span>;</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPhone6,1&quot;</span>])    <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPhone 5S&quot;</span>;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPhone6,2&quot;</span>])    <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPhone 5S&quot;</span>;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPhone7,1&quot;</span>])    <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPhone 6 Plus&quot;</span>;</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPhone7,2&quot;</span>])    <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPhone 6&quot;</span>;</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPhone8,1&quot;</span>])    <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPhone 6s&quot;</span>;</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPhone8,2&quot;</span>])    <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPhone 6s Plus&quot;</span>;</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPhone8,4&quot;</span>])    <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPhone SE&quot;</span>;</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPhone9,1&quot;</span>])    <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPhone 7&quot;</span>;</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPhone9,3&quot;</span>])    <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPhone 7&quot;</span>;</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPhone9,2&quot;</span>])    <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPhone 7 Plus&quot;</span>;</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPhone9,4&quot;</span>])    <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPhone 7 Plus&quot;</span>;</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    </div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    <span class="comment">//iPod 系列</span></div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPod1,1&quot;</span>])      <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPod Touch 1G&quot;</span>;</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPod2,1&quot;</span>])      <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPod Touch 2G&quot;</span>;</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPod3,1&quot;</span>])      <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPod Touch 3G&quot;</span>;</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPod4,1&quot;</span>])      <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPod Touch 4G&quot;</span>;</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPod5,1&quot;</span>])      <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPod Touch 5G&quot;</span>;</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    </div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    <span class="comment">//iPad 系列</span></div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPad1,1&quot;</span>])      <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPad&quot;</span>;</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPad2,1&quot;</span>])      <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPad 2 (WiFi)&quot;</span>;</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPad2,2&quot;</span>])      <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPad 2 (GSM)&quot;</span>;</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPad2,3&quot;</span>])      <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPad 2 (CDMA)&quot;</span>;</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPad2,4&quot;</span>])      <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPad 2 (32nm)&quot;</span>;</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPad2,5&quot;</span>])      <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPad mini (WiFi)&quot;</span>;</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPad2,6&quot;</span>])      <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPad mini (GSM)&quot;</span>;</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPad2,7&quot;</span>])      <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPad mini (CDMA)&quot;</span>;</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    </div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPad3,1&quot;</span>])      <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPad 3(WiFi)&quot;</span>;</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPad3,2&quot;</span>])      <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPad 3(CDMA)&quot;</span>;</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPad3,3&quot;</span>])      <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPad 3(4G)&quot;</span>;</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPad3,4&quot;</span>])      <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPad 4 (WiFi)&quot;</span>;</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPad3,5&quot;</span>])      <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPad 4 (4G)&quot;</span>;</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPad3,6&quot;</span>])      <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPad 4 (CDMA)&quot;</span>;</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    </div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPad4,1&quot;</span>])      <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPad Air&quot;</span>;</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPad4,2&quot;</span>])      <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPad Air&quot;</span>;</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPad4,3&quot;</span>])      <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPad Air&quot;</span>;</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPad5,3&quot;</span>])      <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPad Air 2&quot;</span>;</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPad5,4&quot;</span>])      <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPad Air 2&quot;</span>;</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;i386&quot;</span>])         <span class="keywordflow">return</span> <span class="stringliteral">@&quot;Simulator&quot;</span>;</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;x86_64&quot;</span>])       <span class="keywordflow">return</span> <span class="stringliteral">@&quot;Simulator&quot;</span>;</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;    </div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPad4,4&quot;</span>]</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;        ||[deviceModel isEqualToString:<span class="stringliteral">@&quot;iPad4,5&quot;</span>]</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;        ||[deviceModel isEqualToString:<span class="stringliteral">@&quot;iPad4,6&quot;</span>])      <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPad mini 2&quot;</span>;</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;    </div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;    <span class="keywordflow">if</span> ([deviceModel isEqualToString:<span class="stringliteral">@&quot;iPad4,7&quot;</span>]</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        ||[deviceModel isEqualToString:<span class="stringliteral">@&quot;iPad4,8&quot;</span>]</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        ||[deviceModel isEqualToString:<span class="stringliteral">@&quot;iPad4,9&quot;</span>])      <span class="keywordflow">return</span> <span class="stringliteral">@&quot;iPad mini 3&quot;</span>;</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    </div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;    <span class="keywordflow">return</span> deviceModel;</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;}</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160; </div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;+ (NSString *)getCarrierName {</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    CTTelephonyNetworkInfo *info = [[CTTelephonyNetworkInfo alloc] init];</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;    CTCarrier *carrier = info.subscriberCellularProvider;</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;    <span class="keywordflow">if</span> (!carrier.isoCountryCode) {</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        <span class="comment">// 没有sim卡</span></div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;        <span class="keywordflow">return</span> <span class="stringliteral">@&quot;&quot;</span>;</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    } <span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;        <span class="keywordflow">return</span> carrier.carrierName;</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    }</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;}</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160; </div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;+ (NSString *)getIMSI {</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;    CTTelephonyNetworkInfo *info = [[CTTelephonyNetworkInfo alloc] init];</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;    </div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;    CTCarrier *carrier = [info subscriberCellularProvider];</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;    </div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    NSString *mcc = [carrier mobileCountryCode];</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    NSString *mnc = [carrier mobileNetworkCode];</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    <span class="keywordflow">if</span> (mcc == nil || mnc == nil) {</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;        <span class="keywordflow">return</span> <span class="stringliteral">@&quot;&quot;</span>;</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;    }</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;    </div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    NSString *imsi = [NSString stringWithFormat:@&quot;%@%@&quot;, mcc, mnc];</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;    </div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;    <span class="keywordflow">return</span> imsi;</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;}</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160; </div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;+ (NSString *)getIphoneUUID {</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    NSString *uuid = nil;</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;    uuid = [SAMKeychain passwordForService:kServiceKey account:kUUIDKey];</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;    <span class="keywordflow">if</span> (uuid == nil) {</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;        uuid = [UIDevice currentDevice].identifierForVendor.UUIDString;</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;        [SAMKeychain setPassword:uuid forService:kServiceKey account:kUUIDKey];</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;    }</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;    <span class="keywordflow">return</span> uuid;</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;}</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160; </div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;+ (BOOL)firstAppearAtThisVersionForKey:(NSString *)key</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;{</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;    NSUserDefaults *def = [NSUserDefaults standardUserDefaults];</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;    NSString *name = <span class="stringliteral">@&quot;$CheckKeyForThisVersion&quot;</span>;</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;    NSDictionary *dict = [def persistentDomainForName:name];</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;    NSString *version = dict[@&quot;$app_version&quot;];</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;    <span class="comment">//当前版本大于上次检测到的版本</span></div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;    <span class="keywordflow">if</span> ([[<span class="keyword">self</span> getVersion] compare:version options:NSCaseInsensitiveSearch | NSNumericSearch] == NSOrderedDescending) {</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        [<span class="keyword">self</span> _saveKey:key forDomain:dict withName:name];</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;        <span class="keywordflow">return</span> YES;</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    }</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;    <span class="comment">//如果还不存在这个key</span></div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;    <span class="keywordflow">if</span> (![dict objectForKey:key]) {</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;        [<span class="keyword">self</span> _saveKey:key forDomain:dict withName:name];</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;        <span class="keywordflow">return</span> YES;</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;    }</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;    <span class="keywordflow">return</span> NO;</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;}</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160; </div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;<span class="preprocessor">#pragma mark - Private</span></div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;+ (void)_saveKey:(NSString *)key forDomain:(NSDictionary *)domain withName:(NSString *)name</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;{</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;    NSMutableDictionary *newDict = [NSMutableDictionary dictionaryWithDictionary:domain];</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;    [newDict safetySetObject:@YES forKey:key];</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;    [newDict safetySetObject:[<span class="keyword">self</span> getVersion] forKey:@&quot;$app_version&quot;];</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;    [[NSUserDefaults standardUserDefaults] setPersistentDomain:newDict forName:name];</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;    [[NSUserDefaults standardUserDefaults] synchronize];</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;}</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160; </div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;<span class="keyword">@end</span></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="ainterface_x_h_x_device_manager_html"><div class="ttname"><a href="interface_x_h_x_device_manager.html">XHXDeviceManager</a></div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_device_manager_8h_source.html#l00010">XHXDeviceManager.h:11</a></div></div>
<div class="ttc" id="a_x_h_x_device_manager_8h_html"><div class="ttname"><a href="_x_h_x_device_manager_8h.html">XHXDeviceManager.h</a></div></div>
<div class="ttc" id="ainterface_x_h_x_device_manager_html_a085a7739cdce0d342f7ee650c0152820"><div class="ttname"><a href="interface_x_h_x_device_manager.html#a085a7739cdce0d342f7ee650c0152820">+[XHXDeviceManager getIPAddress]</a></div><div class="ttdeci">NSString * getIPAddress()</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_device_manager_8m_source.html#l00001">XHXDeviceManager.m:50</a></div></div>
<div class="ttc" id="ainterface_x_h_x_device_manager_html_a6c80a82e571c1dc6730b6bd61747d337"><div class="ttname"><a href="interface_x_h_x_device_manager.html#a6c80a82e571c1dc6730b6bd61747d337">+[XHXDeviceManager documentDirectory]</a></div><div class="ttdeci">NSString * documentDirectory()</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_device_manager_8m_source.html#l00001">XHXDeviceManager.m:22</a></div></div>
<div class="ttc" id="ainterface_x_h_x_device_manager_html_a2e073959d4af599e4f30d9328c10f88f"><div class="ttname"><a href="interface_x_h_x_device_manager.html#a2e073959d4af599e4f30d9328c10f88f">+[XHXDeviceManager getIOSVersion]</a></div><div class="ttdeci">NSString * getIOSVersion()</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_device_manager_8m_source.html#l00001">XHXDeviceManager.m:45</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_05f730b1f29a3e373a3d04cb5cb42ea7.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_2d533305e802e0a7e844b4ecd2e2bdb2.html">Classes</a></li><li class="navelem"><a class="el" href="dir_6421e8f138a923188aeb00113878d3d1.html">DeviceManager</a></li><li class="navelem"><a class="el" href="_x_h_x_device_manager_8m.html">XHXDeviceManager.m</a></li>
    <li class="footer">制作者
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.18 </li>
  </ul>
</div>
</body>
</html>
